--******************************************************************************************************************************
--* Licensed Materials - Property of IBM                                                                                       *
--* (c) Copyright IBM Corp. 2008, 2009 All Rights Reserved.                                                                    *
--*                                                                                                                            *
--*US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp*
--******************************************************************************************************************************

-- DDL Statements for foreign keys on Table NC_MESSAGELINE

ALTER TABLE NC_MESSAGELINE 
	ADD CONSTRAINT F1N_MESSAGELINE FOREIGN KEY
		(FK_MESSAGESTRUCT_ID)
	REFERENCES NC_MESSAGESTRUCT
		(PK_MS_ID)
	ON DELETE NO ACTION
	ON UPDATE NO ACTION
	ENFORCED
	ENABLE QUERY OPTIMIZATION;

-- DDL Statements for foreign keys on Table NC_MESSAGELINE_ELEMENT

ALTER TABLE NC_MESSAGELINE_ELEMENT 
	ADD CONSTRAINT F1N_MESSAGELINE_EL FOREIGN KEY
		(LINE_NO,
		 FK_MESSAGESTRUCT_ID)
	REFERENCES NC_MESSAGELINE
		(LINE_NO,
		 FK_MESSAGESTRUCT_ID)
	ON DELETE NO ACTION
	ON UPDATE NO ACTION
	ENFORCED
	ENABLE QUERY OPTIMIZATION;

-- DDL Statements for foreign keys on Table NC_TASKSCHEDULE

ALTER TABLE NC_TASKSCHEDULE 
	ADD CONSTRAINT F1N_TASKSCHEDULE FOREIGN KEY
		(FK_TASK_ID)
	REFERENCES NC_TASK
		(PK_TASK_ID)
	ON DELETE NO ACTION
	ON UPDATE NO ACTION
	ENFORCED
	ENABLE QUERY OPTIMIZATION;

-- DDL Statements for foreign keys on Table R_MESSAGESTRUCT_TASK

ALTER TABLE R_MESSAGESTRUCT_TASK 
	ADD CONSTRAINT F1R_MESSAGESTRUCT_ FOREIGN KEY
		(FK_MESSAGESTRUCT_ID)
	REFERENCES NC_MESSAGESTRUCT
		(PK_MS_ID)
	ON DELETE NO ACTION
	ON UPDATE NO ACTION
	ENFORCED
	ENABLE QUERY OPTIMIZATION;

ALTER TABLE R_MESSAGESTRUCT_TASK 
	ADD CONSTRAINT F2R_MESSAGESTRUCT_ FOREIGN KEY
		(FK_TASK_ID)
	REFERENCES NC_TASK
		(PK_TASK_ID)
	ON DELETE NO ACTION
	ON UPDATE NO ACTION
	ENFORCED
	ENABLE QUERY OPTIMIZATION;

-- DDL Statements for foreign keys on Table R_MSGSTRUCT_RECIPIENT_DELIVINF

ALTER TABLE R_MSGSTRUCT_RECIPIENT_DELIVINF 
	ADD CONSTRAINT F1R_MSGSTRUCT_RECI FOREIGN KEY
		(FK_MESSAGESTRUCT_ID)
	REFERENCES NC_MESSAGESTRUCT
		(PK_MS_ID)
	ON DELETE NO ACTION
	ON UPDATE NO ACTION
	ENFORCED
	ENABLE QUERY OPTIMIZATION;

ALTER TABLE R_MSGSTRUCT_RECIPIENT_DELIVINF 
	ADD CONSTRAINT F3R_MSGSTRUCT_RECI FOREIGN KEY
		(FK_RECIPIENT_ID)
	REFERENCES NC_RECIPIENT
		(PK_RECIPIENT_ID)
	ON DELETE NO ACTION
	ON UPDATE NO ACTION
	ENFORCED
	ENABLE QUERY OPTIMIZATION;

-- DDL Statements for foreign keys on Table R_TASKSCHEDULE_SCHEDULE

ALTER TABLE R_TASKSCHEDULE_SCHEDULE 
	ADD CONSTRAINT F1R_TASKSCHEDULE_S FOREIGN KEY
		(FK_TASKSCHEDULE_ID)
	REFERENCES NC_TASKSCHEDULE
		(PK_TASKSCHEDULE_ID)
	ON DELETE NO ACTION
	ON UPDATE NO ACTION
	ENFORCED
	ENABLE QUERY OPTIMIZATION;

ALTER TABLE R_TASKSCHEDULE_SCHEDULE 
	ADD CONSTRAINT F2R_TASKSCHEDULE_S FOREIGN KEY
		(FK_SCHEDULE_ID)
	REFERENCES NC_SCHEDULE
		(PK_SCHEDULE_ID)
	ON DELETE NO ACTION
	ON UPDATE NO ACTION
	ENFORCED
	ENABLE QUERY OPTIMIZATION;






----------------------------

-- DDL Statements for Views

----------------------------

create view CMOWNERCOUNT(OBJID, OWN_NUMBER) as
SELECT p2.OBJID, count(o.CMID)
FROM CMOBJECTS o left outer join CMREFNOORD2 p1 on p1.CMID = o.CMID
left outer join CMOBJPROPS1 p2 on p1.REFCMID = p2.CMID
GROUP BY p2.OBJID;




-------------------------------
-- DDL Statements for Triggers
-------------------------------

create trigger CMGUIDS_TR
no cascade before insert on CMGUIDS
referencing new as NG
for each row mode db2sql
set NG.GUID = VARCHAR( TIMESTAMP( GENERATE_UNIQUE() ) );


COMMIT WORK;

CONNECT RESET;

TERMINATE;

