@echo off

rem ******************************************************************************************************************************
rem * Licensed Materials - Property of IBM                                                                                       *
rem * (c) Copyright IBM Corp. 2008, 2009 All Rights Reserved.                                                                    *
rem *                                                                                                                            *
rem *US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp*
rem ******************************************************************************************************************************

IF NOT DEFINED LOCALE (SET LOCALE= )
SET LOCEN=0409
SET LOCIT=0410 
SET LOCJP=0411 
SET LOCKO=0412 
SET LOCPO=0415 
SET LOCCHS=0804
SET LOCCHT=0404

IF NOT DEFINED CURINST (SET CURINST= )
IF NOT DEFINED DBNAME (SET DBNAME= )
IF NOT DEFINED DBUSER (SET DBUSER= )
IF NOT DEFINED DBPASSWD (SET DBPASSWD= )
IF NOT DEFINED NF_SCHEMA (SET NF_SCHEMA= )
IF NOT DEFINED STAR_SCHEMA (SET STAR_SCHEMA= )
IF NOT DEFINED REP_USER (SET REP_USER= )
IF NOT DEFINED DATA_HOME (SET DATA_HOME= )
IF NOT DEFINED START_YEAR (SET START_YEAR= )
IF NOT DEFINED END_YEAR (SET END_YEAR= )
IF NOT DEFINED JAVA_HOME (SET JAVA_HOME= )



SET EXITCODE=0
SET MESSAGE= xxx


IF NOT EXIST set_env.bat (
                           SET EXITCODE=4597 
                           GOTO done
                                    ) ELSE (                
                       call set_env.bat
                                  )



IF "%JAVA_HOME%" EQU " " (
SET EXITCODE= 4596 
GOTO done)  


SET CURDIR=%CD%

CD /d "%JAVA_HOME%\bin"
IF "%ERRORLEVEL%" EQU "1" (
SET EXITCODE=4596
GOTO done)

IF NOT EXIST java.exe (
SET EXITCODE= 4598
GOTO done   ) 

CD /d %CURDIR%

set path=%JAVA_HOME%\bin;%path%







REG QUERY "HKCU\Control Panel\International" /v Locale>locale.txt

java com.ibm.rational.vega.dw.SearchAndReplace %LOCIT% locale.txt>nul
IF "%ERRORLEVEL%" EQU "1" (
SET LOCALE=%LOCIT%
call lang\it\messages.bat) 
java com.ibm.rational.vega.dw.SearchAndReplace %LOCJP% locale.txt>nul
IF "%ERRORLEVEL%" EQU "1" (
SET LOCALE=%LOCJP%
call lang\jp\messages.bat)
java com.ibm.rational.vega.dw.SearchAndReplace %LOCKO% locale.txt>nul
IF "%ERRORLEVEL%" EQU "1" (
SET LOCALE=%LOCKO%
call lang\kr\messages.bat)
java com.ibm.rational.vega.dw.SearchAndReplace %LOCPO% locale.txt>nul
IF "%ERRORLEVEL%" EQU "1" (
SET LOCALE=%LOCPO%
call lang\pl\messages.bat)
java com.ibm.rational.vega.dw.SearchAndReplace %LOCCHS% locale.txt>nul
IF "%ERRORLEVEL%" EQU "1" (
SET LOCALE=%LOCCHS%
call lang\zh_CN\messages.bat)
java com.ibm.rational.vega.dw.SearchAndReplace %LOCCHT% locale.txt>nul
IF "%ERRORLEVEL%" EQU "1" (
SET LOCALE=%LOCCHT%
call lang\zh_TW\messages.bat)
java com.ibm.rational.vega.dw.SearchAndReplace %LOCEN% locale.txt>nul
IF "%ERRORLEVEL%" EQU "1" (
SET LOCALE=%LOCEN%
call lang\en\messages.bat)

IF "%LOCALE%" EQU " " (
SET LOCALE=%LOCEN%
call lang\en\messages.bat)

SET EXITCODE=0
SET MESSAGE=No errors

IF "%1" EQU "-validate" (GOTO validate)
REM IF "%2" NEQ "" (IF "%2" EQU "-validate" (GOTO validate ))
REM IF "%3" NEQ "" (IF "%3" EQU "-validate" (GOTO validate ))



SET /A SILENT=0
IF "%1" EQU "-silent" (
SET /A SILENT=1) 

SET DB2_CMD=
IF "%1" EQU "-debug" (SET DB2_CMD= db2 -tvsf ) ELSE (SET DB2_CMD= db2 -tsf)
IF "%2" NEQ "" (IF "%2" EQU "-debug" (SET DB2_CMD= db2 -tvf ) ELSE (SET DB2_CMD= db2 -tf))

IF %SILENT% EQU 0 (
ECHO %CRREWECH001%)

IF %SILENT% EQU 0 (
SET /P CURINST=%CRREWPRMPT001% 
)
IF "%CURINST%" EQU " " (
SET EXITCODE=%CRREW4501E%
SET MESSAGE=%CRREWMSGE001%
GOTO done)  

IF %SILENT% EQU 0 (
SET /P DBNAME=%CRREWPRMPT002%
)
IF "%DBNAME%" EQU " " (
SET EXITCODE=%CRREW4502E%
SET MESSAGE=%CRREWMSGE002%

GOTO done) 

IF %SILENT% EQU 0 (
SET /P DBUSER=%CRREWPRMPT003%
)
IF "%DBUSER%" EQU " " (
SET EXITCODE=%CRREW4503E%
SET MESSAGE=%CRREWMSGE003%

GOTO done)

IF %SILENT% EQU 0 (
SET /P DBPASSWD=%CRREWPRMPT004%
)

IF "%DBDBPASSWD%" EQU " " (
SET EXITCODE=%CRREW4504E%
SET MESSAGE=%CRREWMSGE004%

GOTO done)

IF %SILENT% EQU 0 (
SET /P DATA_HOME=%CRREWPRMPT008%
)
IF "%DATA_HOME%" EQU " " (
SET EXITCODE=%CRREW4508E%
SET MESSAGE=%CRREWMSGE008%
GOTO done)

IF %SILENT% EQU 1 (
SETLOCAL ENABLEDELAYEDEXPANSION
db2 connect to %DBNAME% user %DBUSER% using "%DBPASSWD%"
db2 "SELECT COUNT(*) FROM CMCAPACITY"
IF "!ERRORLEVEL!" EQU "0" (
GOTO done)
)

SET DATA_HOME=%DATA_HOME%\%DBNAME%

IF NOT EXIST logs\nul (MKDIR logs) ELSE (
RMDIR /S /Q logs
MKDIR logs
)
IF "%ERRORLEVEL%" NEQ "0" (
SET EXITCODE=%CRREW4576E%
SET MESSAGE=%CRREWMSGE076%
GOTO done)

db2 "CREATE DATABASE %DBNAME% USING CODESET UTF-8 TERRITORY US" > .\logs\createDB.log
java com.ibm.rational.vega.dw.SearchAndReplace SQL "%CD%"\logs\createDB.log>nul
IF "%ERRORLEVEL%" EQU "1" (
	SET MESSAGE=%CRREWMSGE013%  
	SET EXITCODE=%CRREW4513E%
	echo %CRREWECH003%
GOTO done)

db2 update db cfg for %DBNAME% using APPLHEAPSZ 1024
db2 update db cfg for %DBNAME% using LOCKTIMEOUT 240

db2 connect to %DBNAME% user %DBUSER% using "%DBPASSWD%" >.\logs\connectDB.log

db2 "create bufferpool CBP_32K  SIZE 1000 PAGESIZE 32768">.\logs\bufferpool.log
db2 "create bufferpool CBP_4K  SIZE 1000 PAGESIZE 4096">>.\logs\bufferpool.log
java com.ibm.rational.vega.dw.SearchAndReplace SQLSTATE "%CD%"\logs\bufferpool.log>nul
IF "%ERRORLEVEL%" EQU "1" ( 
SET MESSAGE=%CRREWMSGE014%  
SET EXITCODE=%CRREW4514E%
ECHO %CRREWECH004%
GOTO done)

db2 force applications all
db2stop force
db2start
db2 connect to %DBNAME% user %DBUSER% using "%DBPASSWD%" >>.\logs\connectDB.log
db2 connect to %DBNAME% user %DBUSER% using "%DBPASSWD%" >>.\logs\connectDB.log


db2 "CREATE TEMPORARY TABLESPACE CTEMPSPACE32K IN DATABASE PARTITION GROUP IBMTEMPGROUP PAGESIZE 32768 MANAGED BY SYSTEM USING ('%DATA_HOME%\data1\tempspace32k') BUFFERPOOL CBP_32K " >.\logs\tbspaces.log
db2 "CREATE USER TEMPORARY TABLESPACE USRTMP4K IN DATABASE PARTITION GROUP IBMDEFAULTGROUP PAGESIZE 4096 MANAGED BY AUTOMATIC STORAGE BUFFERPOOL CBP_4K" >>.\logs\tbspaces.log
db2 "CREATE REGULAR TABLESPACE CTBS_4K IN DATABASE PARTITION GROUP IBMDEFAULTGROUP PAGESIZE 4096 MANAGED BY DATABASE USING (FILE '%DATA_HOME%\data1\ctbs_4k.1' 10000) BUFFERPOOL CBP_4K AUTORESIZE YES INCREASESIZE 50 M MAXSIZE NONE DROPPED TABLE RECOVERY ON">>.\logs\tbspaces.log
java com.ibm.rational.vega.dw.SearchAndReplace SQLSTATE "%CD%"\logs\tbspaces.log>nul
IF "%ERRORLEVEL%" EQU "1" ( 
SET MESSAGE=%CRREWMSGE015%  
SET EXITCODE=%CRREW4515E%
ECHO %CRREWECH005%
GOTO done)

db2 connect to %DBNAME% user %DBUSER% using "%DBPASSWD%" >>.\logs\connectDB.log
db2 -tvf cmstore.ddl>logs\cmstore.log
java com.ibm.rational.vega.dw.SearchAndReplace SQLSTATE "%CD%"\logs\cmstore.log>nul
IF "%ERRORLEVEL%" EQU "1" (
	SET MESSAGE=%CRREWMSGE077%
	SET EXITCODE=%CRREW4577E%
	echo %CRREWECH022%
GOTO done)


java com.ibm.rational.vega.dw.SearchAndReplace $CS_SCHEMA %DBUSER% db2move.lst_original move\db2move.lst
pushd move
db2move %DBNAME% import -l .\lobs
IF "%ERRORLEVEL%" EQU "1" (
	SET MESSAGE=%CRREWMSGE027%
	SET EXITCODE=%CRREW4527E%
	popd
GOTO done)

popd
db2 connect to %DBNAME% user %DBUSER% using "%DBPASSWD%" >>.\logs\connectDB.log
db2 -tvf cmstore_trig.ddl>logs\cmstore_trig.log
java com.ibm.rational.vega.dw.SearchAndReplace SQLSTATE "%CD%"\logs\cmstore_trig.log>nul
IF "%ERRORLEVEL%" EQU "1" (
	SET MESSAGE=%CRREWMSGE078%
	SET EXITCODE=%CRREW4578E%
	echo %CRREWECH023%
	GOTO done
)

GOTO done

:validate

SET EXITCODE=0
SET MESSAGE=No errors

IF NOT DEFINED CURINST (
SET EXITCODE=%CRREW4501E%
SET MESSAGE=%CRREWMSGE001%
GOTO done)  

IF NOT DEFINED DBNAME (
SET EXITCODE=%CRREW4502E%
SET MESSAGE=%CRREWMSGE002%
GOTO done)

IF NOT DEFINED DBUSER (
SET EXITCODE=%CRREW4503E%
SET MESSAGE=%CRREWMSGE003%
GOTO done)

IF NOT DEFINED DBPASSWD (
SET EXITCODE=%CRREW4504E%
SET MESSAGE=%CRREWMSGE004%
GOTO done)

IF NOT DEFINED DATA_HOME (
SET EXITCODE=%CRREW4508E%
SET MESSAGE=%CRREWMSGE008%
GOTO done)

REG QUERY "HKCU\Control Panel\International" /v Locale>nul
IF "%ERRORLEVEL%" NEQ "0" (
SET EXITCODE=%CRREW4585E%
SET MESSAGE=%CRREWMSGE085%
GOTO done
)

IF "%CURINST%" EQU " " (
SET EXITCODE=%CRREW4501E%
SET MESSAGE=%CRREWMSGE001%
GOTO done)  

IF "%DBNAME%" EQU " " (
SET EXITCODE=%CRREW4502E%
SET MESSAGE=%CRREWMSGE002%
GOTO done)

IF "%DBUSER%" EQU " " (
SET EXITCODE=%CRREW4503E%
SET MESSAGE=%CRREWMSGE003%
GOTO done)

IF "%DBPASSWD%" EQU " " (
SET EXITCODE=%CRREW4504E%
SET MESSAGE=%CRREWMSGE004%
GOTO done)

db2ilist >db2ilist.txt
java com.ibm.rational.vega.dw.SearchAndReplace %CURINST% db2ilist.txt
IF "%ERRORLEVEL%" EQU "0" (
DEL /Q db2ilist.txt
SET EXITCODE=%CRREW4501E%
SET MESSAGE=%CRREWMSGE001%
GOTO done)  

DEL /Q db2ilist.txt

db2 attach to  %CURINST% user %DBUSER% using  "%DBPASSWD%"
IF "%ERRORLEVEL%" NEQ "0" (
SET EXITCODE=%CRREW4584E%
SET MESSAGE=%CRREWMSGE084%
GOTO done)  

IF "%DATA_HOME%" EQU " " (
SET EXITCODE=%CRREW4508E%
SET MESSAGE=%CRREWMSGE008%
GOTO done)



GOTO done

:done 
db2 connect reset 
db2 terminate
echo %MESSAGE%:%EXITCODE%
echo %CRREWECH002%
EXIT /B %EXITCODE%